---
jupytext:
  formats: md:myst
  text_representation:
    extension: .md
    format_name: myst
    format_version: 0.13
    jupytext_version: 1.16.4
kernelspec:
  display_name: Python 3 (ipykernel)
  language: python
  name: python3
---

# OWL disjoint X Y minimalistic

```{code-cell} ipython3
import rdflib # https://rdflib.readthedocs.io/en/stable/ 
import owlrl # https://pypi.org/project/owlrl/

# utility fn: only show ttl paragraphs with specific strings
def focus(focus_string_list, ttl):
    return "\n\n".join( [ paragraph for paragraph in ttl.split("\n\n") \
        if any( [ focus_string in paragraph for focus_string in focus_string_list ] ) ] )
```

```{code-cell} ipython3
ttl = """
@prefix : <http://example.org/#> .
@prefix owl: <http://www.w3.org/2002/07/owl#> .

:X a owl:Class .
:Y a owl:Class ; owl:disjointWith :X .

:x a :X .
:y a :Y .
:xy a :X, :Y . 
"""
g = rdflib.Graph().parse(data=ttl)
```

```{code-cell} ipython3
# before inferencing
interesting = ["xy"]
print(focus(interesting, g.serialize()))
```

```{code-cell} ipython3
# 
owlrl.DeductiveClosure(owlrl.OWLRL_Semantics,
    axiomatic_triples = False).expand(g)
# after inferencing
print(focus(interesting, g.serialize()))
```

```{code-cell} ipython3

```

```{code-cell} ipython3

```
